var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { FaTimes } from 'react-icons/fa';
var Filter = function (_a) {
    var parameters = _a.parameters, onApply = _a.onApply, onClose = _a.onClose, initialFilters = _a.initialFilters, fnHandlePushHistory = _a.fnHandlePushHistory;
    var _b = React.useState({}), filterValues = _b[0], setFilterValues = _b[1];
    var _c = React.useState({}), errors = _c[0], setErrors = _c[1];
    React.useEffect(function () {
        if (initialFilters) {
            setFilterValues(initialFilters);
        }
    }, [initialFilters]);
    var validateField = function (parameter, value) {
        var _a;
        if (!value) {
            if ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) {
                return 'Trường này là bắt buộc';
            }
            return '';
        }
        var numValue = Number(value);
        if (parameter.data_type === 'integer' || parameter.data_type === 'double') {
            if (isNaN(numValue)) {
                return 'Giá trị không hợp lệ';
            }
            var validation = __assign({}, parameter.validation);
            if (validation.gte)
                if (validation.gte !== undefined && numValue < validation.gte) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i l\u1EDBn h\u01A1n ho\u1EB7c b\u1EB1ng ".concat(validation.gte);
                }
            if (validation.gt)
                if (validation.gt !== undefined && numValue <= validation.gt) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i l\u1EDBn h\u01A1n ".concat(validation.gt);
                }
            if (validation.lt)
                if (validation.lt !== undefined && numValue >= validation.lt) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i nh\u1ECF h\u01A1n ".concat(validation.lt);
                }
            if (validation.lte)
                if (validation.lte !== undefined && numValue > validation.lte) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i nh\u1ECF h\u01A1n ho\u1EB7c b\u1EB1ng ".concat(validation.lte);
                }
        }
        return '';
    };
    var hasEmptyRequiredFields = function () {
        return parameters.some(function (parameter) {
            var _a;
            return ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) &&
                (filterValues[parameter.code] === undefined ||
                    filterValues[parameter.code] === '' ||
                    filterValues[parameter.code] === null);
        });
    };
    var handleClearValue = function (code) {
        setFilterValues(function (prev) {
            var newFilters = __assign({}, prev);
            delete newFilters[code];
            return newFilters;
        });
        setErrors(function (prev) {
            var newErrors = __assign({}, prev);
            delete newErrors[code];
            return newErrors;
        });
    };
    var handleInputChange = function (code, value, dataType) {
        var _a;
        var parsedValue = value;
        switch (dataType) {
            case 'integer':
                parsedValue = parseInt(value);
                break;
            case 'double':
                parsedValue = parseFloat(value);
                break;
            case 'boolean':
                parsedValue = Boolean(value);
                break;
            case 'datetime':
            case 'date':
                parsedValue = new Date(value).toISOString();
                break;
            default:
                parsedValue = value;
        }
        var newFilters = __assign(__assign({}, filterValues), (_a = {}, _a[code] = parsedValue, _a));
        setFilterValues(newFilters);
        setErrors(function (param) {
            var _a;
            return (__assign(__assign({}, param), (_a = {}, _a[code] = '', _a)));
        });
    };
    var handleApply = function () {
        var newErrors = {};
        var hasErrors = false;
        parameters.forEach(function (parameter) {
            var error = validateField(parameter, filterValues[parameter.code]);
            if (error) {
                newErrors[parameter.code] = error;
                hasErrors = true;
            }
        });
        setErrors(newErrors);
        if (!hasErrors) {
            onApply(filterValues);
        }
    };
    var convertValueParameter = function (value) {
        if (!value)
            return '';
        var regex$$ = /^\$\$(.+)/;
        var match = value.match(regex$$);
        if (!match)
            return value;
        var command = match[1];
        var now = new Date();
        now.setHours(0, 0, 0, 0);
        if (command.includes('now')) {
            var offsetMatch = command.match(/([-+])(\d+)(days|months|years|weeks|hours|minutes|seconds|milliseconds)$/);
            if (offsetMatch) {
                var _ = offsetMatch[0], operator = offsetMatch[1], amount = offsetMatch[2], unit = offsetMatch[3];
                var offset = parseInt(amount) * (operator === '-' ? -1 : 1);
                var date = new Date();
                switch (unit.replace(/s$/, '')) {
                    case 'day':
                        date.setDate(date.getDate() + offset);
                        break;
                    case 'hour':
                        date.setHours(date.getHours() + offset);
                        break;
                    case 'minute':
                        date.setMinutes(date.getMinutes() + offset);
                        break;
                }
                return date.toISOString();
            }
            return now.toISOString();
        }
        if (command.includes('today')) {
            var offsetMatch = command.match(/([-+])(\d+)(days|months|years|weeks|hours|minutes|seconds|milliseconds)?$/);
            if (offsetMatch) {
                var _ = offsetMatch[0], operator = offsetMatch[1], days = offsetMatch[2];
                var offset = parseInt(days) * (operator === '-' ? -1 : 1);
                var date = new Date();
                date.setHours(0, 0, 0, 0);
                date.setHours(12);
                date.setDate(date.getDate() + offset);
                date.setHours(0, 0, 0, 0);
                return date.toLocaleDateString('en-CA');
            }
            return now.toLocaleDateString('en-CA');
        }
        switch (command) {
            case 'year':
                return now.getFullYear();
            case 'month':
                return now.getMonth() + 1;
            case 'day':
                return now.getDate();
            default:
                return value;
        }
    };
    var renderInput = function (parameter) {
        var value = parameter.code
            ? filterValues[parameter.code] !== undefined
                ? filterValues[parameter.code]
                : convertValueParameter(parameter.default) || ''
            : '';
        var error = parameter.code ? errors[parameter.code] : '';
        var inputPropsClass = {
            className: "filter-input ".concat(error ? 'filter-input--error' : ''),
            'aria-invalid': !!error,
        };
        var renderField = function () {
            var showClearButton = value !== '' && value !== false;
            var clearButton = showClearButton ? (_jsx("button", { type: "button", className: "clear-button", onClick: function () { return handleClearValue(parameter.code); }, "aria-label": "Clear value", style: { position: 'absolute', right: '10px', top: '12px', cursor: 'pointer' }, children: _jsx(FaTimes, { size: 15, style: { display: 'block' } }) })) : null;
            var formatDate = function (val) {
                if (!val)
                    return '';
                var date = new Date(val);
                if (isNaN(date.getTime()))
                    return '';
                return date.toISOString().split('T')[0];
            };
            switch (parameter.input_type) {
                case 'number':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "number", value: Number(value), onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
                case 'checkbox':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "checkbox", checked: !!value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.checked, parameter.data_type);
                            } })) }));
                case 'date':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "date", value: formatDate(value), onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
                case 'datetime':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "datetime-local", value: formatDate(value), onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
                case 'dropdown':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("select", __assign({}, inputPropsClass, { value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                }, children: _jsx("option", { value: "", children: "Select..." }) })), clearButton] }));
                default:
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "text", value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
            }
        };
        return (_jsxs("div", { className: "filter-input-item", children: [renderField(), error && _jsx("p", { className: "filter-error", children: error })] }));
    };
    return (_jsx("div", { className: "filter-overlay", children: _jsxs("div", { className: "filter-modal", children: [_jsxs("div", { className: "filter-modal__header", style: { display: 'flex', justifyContent: 'space-between', alignItems: 'center' }, children: [_jsx("p", { className: "filter-modal__header--text", children: "L\u1ECDc d\u1EEF li\u1EC7u" }), _jsx("button", { className: "filter-modal__header--btn-close", disabled: hasEmptyRequiredFields(), onClick: onClose, children: _jsx(FaTimes, { size: 30, style: { display: 'block' } }) })] }), _jsx("div", { className: "filter-content", children: (parameters === null || parameters === void 0 ? void 0 : parameters.length) > 0 &&
                        parameters.map(function (parameter) {
                            var _a;
                            return (_jsxs("div", { className: "filter-item", children: [_jsxs("label", { children: [parameter.label || parameter.code, ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) && _jsx("span", { className: "required", children: "*" })] }), renderInput(parameter)] }, parameter.code));
                        }) }), _jsx("div", { className: "filter-actions", children: _jsx("button", { className: "btn btn__primary filter-actions__accept", onClick: handleApply, children: "L\u1ECDc d\u1EEF li\u1EC7u" }) })] }) }));
};
export default Filter;
